VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} formletter2pdf_form 
   Caption         =   "formletter2pdf"
   ClientHeight    =   8430
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   7605
   OleObjectBlob   =   "formletter2pdf_form.frx":0000
   StartUpPosition =   2  'Bildschirmmitte
End
Attribute VB_Name = "formletter2pdf_form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' **********************************************************************************************
' formletter2pdf
'
' Copyright 2013 Christian Bartl (www.formletter2pdf.com)
'
' Licensed under the Apache License, Version 2.0 (the "License");
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
'
' http://www.apache.org/licenses/LICENSE-2.0
'
' Unless required by applicable law or agreed to in writing, software
' distributed under the License is distributed on an "AS IS" BASIS,
' WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
' See the License for the specific language governing permissions and
' limitations under the License.
'
' This notice must appear in all copies of the script.
' **********************************************************************************************

Private Sub UserForm_Initialize()
    ' create other file type selection values
    Me.filetype_other_select.AddItem ("Word 97-2003 Document (.doc)")
    Me.filetype_other_select.AddItem ("Single File Web Page (.mht)")
    Me.filetype_other_select.AddItem ("Web Page (.htm)")
    Me.filetype_other_select.AddItem ("Web Page, Filtered (.htm)")
    Me.filetype_other_select.AddItem ("Rich Text Format (.rte)")
    Me.filetype_other_select.AddItem ("Plain Text (.txt)")

    ' set default filetype
    If StorageFiletype <> "" Then
        TmpFiletype = StorageFiletype
    Else
        TmpFiletype = DefaultFiletype
    End If
    
    Me.filetype_pdf.Value = 0
    Me.filetype_docx.Value = 0
    Me.filetype_other.Value = 0
    If TmpFiletype = "docx" Then
        Me.filetype_docx.Value = 1
    ElseIf TmpFiletype = "Word 97-2003 Document (.doc)" Then
        Me.filetype_other.Value = 1
        Me.filetype_other_select.Value = "Word 97-2003 Document (.doc)"
    ElseIf TmpFiletype = "Single File Web Page (.mht)" Then
        Me.filetype_other.Value = 1
        Me.filetype_other_select.Value = "Single File Web Page (.mht)"
    ElseIf TmpFiletype = "Web Page (.htm)" Then
        Me.filetype_other.Value = 1
        Me.filetype_other_select.Value = "Web Page (.htm"
    ElseIf TmpFiletype = "Web Page, Filtered (.htm)" Then
        Me.filetype_other.Value = 1
        Me.filetype_other_select.Value = "Web Page, Filtered (.htm)"
    ElseIf TmpFiletype = "Rich Text Format (.rte)" Then
        Me.filetype_other.Value = 1
        Me.filetype_other_select.Value = "Rich Text Format (.rte)"
    ElseIf TmpFiletype = "Plain Text (.txt)" Then
        Me.filetype_other.Value = 1
        Me.filetype_other_select.Value = "Plain Text (.txt)"
    Else
        Me.filetype_pdf.Value = 1
    End If

    ' set default filelocation
    If StorageFilelocation <> "" Then
        Me.filelocation.Value = StorageFilelocation
    Else
        If DefaultFilelocation = "desktop" Or DefaultFilelocation = "Desktop" Then
            If System.OperatingSystem Like "*Mac*" Then
                Me.filelocation.Value = MacScript("return (path to desktop folder) as String")
            Else
                Me.filelocation.Value = CreateObject("WScript.Shell").SpecialFolders("Desktop")
            End If
        Else
            Me.filelocation.Value = DefaultFilelocation
        End If
    End If
    
        ' do not predefine path in office 2016 because of rights management
    If System.OperatingSystem Like "*Mac*" And Val(Application.Version) > 15 Then
        Me.filelocation.Value = ""
    End If
    
    ' set default foldername
    If StorageFoldername <> "" Then
        Me.foldername.Value = StorageFoldername
    Else
        Me.foldername.Value = DefaultFoldername
    End If
    
    ' set default filenamepattern
    If StorageFilenamepattern <> "" Then
        Me.filenamepattern.Value = StorageFilenamepattern
    Else
        Me.filenamepattern.Value = DefaultFilenamepattern
    End If

End Sub


Private Sub filetype_other_select_Change()
    Me.filetype_pdf.Value = 0
    Me.filetype_docx.Value = 0
    Me.filetype_other.Value = 1
End Sub


Private Sub label_filename_hint_action_Click()
    Dim Message As String
    
    For Each Column In ActiveDocument.MailMerge.DataSource.DataFields
        Message = Message & "{" & Column.Name & "}" & vbCrLf
    Next Column
    
    MsgBox Message, vbOKOnly + vbInfo
End Sub


Private Sub FileLocation_choose_Click()

    If System.OperatingSystem Like "*Mac*" Then

            'define Variables
            Dim MacScriptPath As String
            
            ' create browse for folder dialog
            On Error Resume Next
            
            If System.OperatingSystem Like "*Mac*" And Val(Application.Version) > 15 Then
                MacScriptPath = MacScript("(choose folder with prompt ""Choose the location where the folder with the generated files should be stored.""" & _
    "default location alias """ & MacScript("return (path to desktop folder) as String") & """) as string")
            Else
                MacScriptPath = MacScript("(choose folder with prompt ""Choose the location where the folder with the generated files should be stored.""" & _
    "default location alias """ & Me.filelocation.Value & """) as string")
            End If
            
            On Error GoTo 0
            
            ' save choosen path to FileLocation
            If MacScriptPath <> "" Then
                Me.filelocation.Value = MacScriptPath
            End If
        
    Else
    
        ' define variables
        Dim ShellApplication As Object
        Dim BrowseFileLocation As Object
    
        ' create browse for folder dialog
        Set ShellApplication = CreateObject("Shell.Application")
        Set BrowseFileLocation = ShellApplication.BrowseForFolder(0, "Choose the location where the folder with the generated files should be stored.", 0, 16)
       
        ' save choosen path to FileLocation
        If BrowseFileLocation Is Nothing Then
        ElseIf BrowseFileLocation = "Desktop" Then
            Me.filelocation.Value = CreateObject("WScript.Shell").SpecialFolders("Desktop")
        Else
            Me.filelocation.Value = BrowseFileLocation.items().Item().Path
        End If
    
    End If
    
End Sub


Private Sub cancel_Click()

    ' quit macro
    Unload Me
    
End Sub


Private Sub create_Click()
    
    '
    ' define variables
    '
    Dim Filetype As String
    Dim FileExtension As String
    Dim Location As String
    Dim Folder As String
    Dim Filename As String
    Dim Path As String
    Dim Tstamp As String
    Dim Counter As Integer
    Dim EmptyCounter As Integer
    Dim isDir As Integer
    Dim File As String
    Dim Targetfile As String
    Dim Documentname As String


    '
    ' get values from form
    '
    
        ' get filetype
    Filetype = "pdf"
    If Me.filetype_docx.Value = True Then Filetype = "docx"
    
    If Me.filetype_other.Value = True Then
        If Me.filetype_other_select.Value = "" Then
            MsgBox "No other file type defined. Please choose a file type from the selectbox.", vbOKOnly + vbCritical
            Exit Sub
        Else
            Filetype = Me.filetype_other_select.Value
        End If
    End If
    
        ' get FileLocation
    If Me.filelocation.Value = "" Then
        MsgBox "Please provide a storage location where the generated files can be saved to.", vbOKOnly + vbCritical
        Exit Sub
    Else
        Location = Me.filelocation.Value
    End If
    
        ' get foldername
    If Me.foldername.Value = "" Then
        MsgBox "Please provide a folder name.", vbOKOnly + vbCritical
        Exit Sub
    Else
        Folder = Me.foldername.Value
    End If
    
        ' get Filename
    If IsEmpty(Me.filenamepattern.Value) Then
        MsgBox "Please provide a file name pattern.", vbOKOnly + vbCritical
        Exit Sub
    Else
        Filename = Me.filenamepattern.Value
    End If
    
    
    '
    ' preserve values from form for the next run of the macro
    '
    
    StorageFiletype = Filetype
    StorageFilelocation = Location
    StorageFoldername = Folder
    StorageFilenamepattern = Filename
        
        
    '
    ' determine path and create target folder
    '
    
        ' determine storage location path
    Tstamp = Format(Now, "dd.mm.yyyy-hh.mm.ss")
    Folder = Replace(Folder, "{%timestamp%}", Tstamp)
    
    If System.OperatingSystem Like "*Mac*" And Val(Application.Version) > 15 Then
        Path = "/Volumes/" & Replace(Location, ":", "/") & Folder & "/"
    ElseIf System.OperatingSystem Like "*Mac*" Then
        Path = Location & Folder & ":"
    Else
        Path = Location & "\" & Folder & "\"
    End If
    
        ' check if target folder already exists, abort if, create if not
    If System.OperatingSystem Like "*Mac*" And Val(Application.Version) > 15 Then
        On Error GoTo OfficeMacWorkaround
        tmpPath = Location & Folder & ":"
        isDir = Len(Dir(tmpPath, vbDirectory))
        isDir = 1
    ElseIf System.OperatingSystem Like "*Mac*" Then
        If MacScript("tell application " & Chr(34) & "Finder" & Chr(34) & Chr(13) & "exists folder " & Chr(34) & Path & Chr(34) & Chr(13) & "end tell" & Chr(13)) = True Then
            isDir = 1
        Else
            isDir = 0
        End If
        
        On Error GoTo ErrorHandling
    Else
        isDir = Len(Dir(Path, vbDirectory))
        On Error GoTo ErrorHandling
    End If

    ' workaround for office for mac 2015 - begin
OfficeMacWorkaround:
    If Err.Number = 53 Then
        isDir = 0
    End If
    
    
    On Error GoTo ErrorHandling
    ' workaround for office for mac 2015 - end
    
    If isDir = 0 Then
        If System.OperatingSystem Like "*Mac*" And Val(Application.Version) > 15 Then
            MkDir Path
        ElseIf System.OperatingSystem Like "*Mac*" Then
           MacScript ("tell application " & Chr(34) & "Finder" & Chr(34) & Chr(13) & "make new folder at " & Chr(34) & Location & Chr(34) & " with properties {name: " & Chr(34) & Folder & Chr(34) & "}" & Chr(13) & "end tell" & Chr(13))
        Else
            Dim fso, f
            Set fso = CreateObject("Scripting.FileSystemObject")
            fso.CreateFolder (Path)
        End If
        
        On Error GoTo ErrorHandling
    Else
        MsgBox "A folder with the given name already exists at the storage location. Please provide another folder name or change the storage location.", vbOKOnly + vbCritical
        Exit Sub
    End If
    
    
    '
    ' get document name
    '
    
    Dim thisDocument As Document
    Set thisDocument = ActiveDocument
    
    If InStrRev(thisDocument.Name, ".") <> 0 Then
        Documentname = Left(thisDocument.Name, InStrRev(thisDocument.Name, ".") - 1)
    Else
        Documentname = thisDocument.Name
    End If


    '
    ' show info dialog and hide word application for better performance
    '
    
    If System.OperatingSystem Like "*Mac*" Then
        If MsgBox("The process of saving the single files can take a couple of minutes, depending on the amount of files. The formletter2pdf window will be hidden during this time. Want to continue?", vbOKCancel + vbInformation) = vbCancel Then Exit Sub
         formletter2pdf_form.Hide
    Else
        If MsgBox("The process of saving the single files can take a couple of minutes, depending on the amount of files. Microsoft Word will be hidden during this time to increase the performance. Want to continue?", vbOKCancel + vbInformation) = vbCancel Then Exit Sub
    End If
    Application.Visible = False
    Application.ScreenUpdating = False

    
    '
    ' save form letter to single files
    '
    
    Counter = 1
    
    With ActiveDocument.MailMerge
        
        ' determine amount of files
        .DataSource.ActiveRecord = wdLastRecord
        RecordCount = .DataSource.ActiveRecord
        .DataSource.ActiveRecord = 1
        
        Do
            ' create single files
            .Destination = wdSendToNewDocument
            .SuppressBlankLines = True

            With .DataSource
                .FirstRecord = .ActiveRecord
                .LastRecord = .ActiveRecord
            End With
            
            ' update dynamic fields in created documents; remove comment from next line if needed
            'ActiveDocument.Fields.Update
            
            ' determine filename
            With .DataSource
                
                    ' replace datasource field markers
                EmptyCounter = 0
                File = Filename
                For Each Column In .DataFields
                    File = Replace(File, "{" & Column.Name & "}", Column.Value)
                    If Column.Value = "" Then EmptyCounter = EmptyCounter + 1
                Next Column
                
                    ' skip actual record if all columns of the record are empty
                If EmptyCounter = .DataFields.Count Then
                    Counter = Counter - 1
                    GoTo NextLoop
                End If
                
                    ' replace generic counter marker
                File = Replace(File, "{%counter%}", Counter)
                                
                    ' replace document name marker
                File = Replace(File, "{%filename%}", Documentname)
                
                    ' replace all characters which are not allowed in Filenames (Chr(34) = ")
                File = Replace(File, "\", "")
                File = Replace(File, "/", "")
                File = Replace(File, ":", "")
                File = Replace(File, "*", "")
                File = Replace(File, "?", "")
                File = Replace(File, Chr(34), "")
                File = Replace(File, "<", "")
                File = Replace(File, ">", "")
                File = Replace(File, "|", "")
                
            End With
            
            ' surpress any mailmerge error
            .Execute Pause:=False
       
            ' save the single document
            Targetfile = Path & File & "."
            
            If Filetype = "docx" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "docx", FileFormat:=wdFormatDocumentDefault
            ElseIf Filetype = "Word 97-2003 Document (.doc)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "doc", FileFormat:=wdFormatDocument97
            ElseIf Filetype = "Single File Web Page (.mht)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "mht", FileFormat:=wdFormatWebArchive
            ElseIf Filetype = "Web Page (.htm)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "htm", FileFormat:=wdFormatHTML
            ElseIf Filetype = "Web Page, Filtered (.htm)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "htm", FileFormat:=wdFormatFilteredHTML
            ElseIf Filetype = "Rich Text Format (.rte)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "rte", FileFormat:=wdFormatText
            ElseIf Filetype = "Plain Text (.txt)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "txt", FileFormat:=wdFormatEncodedText
            Else
                ActiveDocument.SaveAs Filename:=Targetfile & "pdf", FileFormat:=wdFormatPDF
                
                ' alternative command to export document as pdf, with the possibility to set different export options
                'ActiveDocument.ExportAsFixedFormat OutputFileName:=Targetfile & "pdf", ExportFormat:=wdExportFormatPDF, OpenAfterExport:=False, OptimizeFor:=wdExportOptimizeForPrint, Range:=wdExportAllDocument, Item:=wdExportDocumentContent, IncludeDocProps:=True, KeepIRM:=True, CreateBookmarks:=wdExportCreateWordBookmarks, DocStructureTags:=True, BitmapMissingFonts:=True, UseISO19005_1:=False
            End If
            
            ' close the single document
            ActiveDocument.Close False
       
            ' get next record from datasource
NextLoop:
            If .DataSource.ActiveRecord < RecordCount Then
               .DataSource.ActiveRecord = .DataSource.ActiveRecord + 1
                Counter = Counter + 1
            Else
                Exit Do
            End If
        Loop
    End With
    
    
    '
    ' show result and error messages and unhide word application
    '
    
ErrorHandling:

    Application.Visible = True
    Application.ScreenUpdating = True

    If Err.Number = 75 Then
        MsgBox "You do not have proper file system rights on the given storage location. Please choose another storage location.", vbOKOnly + vbCritical
    ElseIf Err.Number = 76 Then
        MsgBox "The given location isn't a valid storage location. Please choose another storage location.", vbOKOnly + vbCritical
    ElseIf Err.Number = 4198 Then
        MsgBox "formletter2pdf has been aborted, because an invalid file name has been detected. Please check the values of the fields used in the file name pattern for invalid characters and run formletter2pdf again.", vbOKOnly + vbCritical
        Unload Me
    ElseIf Err.Number = 5852 Then
        MsgBox "formletter2pdf could not save single files, because this document isn't a form letter. Please start the mail merge function first and then run formletter2pdf again.", vbOKOnly + vbCritical
        Unload Me
    ElseIf Err.Number > 0 Then
        MsgBox "Unknown Error: " & Err.Number & " - Please try to run formletter2pdf again.", vbOKOnly + vbCritical
        Unload Me
    Else
        If Counter > 1 Then
            MsgBox Counter & " form letters exported successfully!", vbOKOnly + vbInformation
        Else
            MsgBox Counter & " form letter exported successfully!", vbOKOnly + vbInformation
        End If
        Unload Me
    End If
    
    
End Sub


Private Sub label_donate_Click()
    ActiveDocument.FollowHyperlink Address:="http://www.formletter2pdf.com/en/?donate=1", NewWindow:=True
End Sub

Private Sub label_subheadline_Click()
    ActiveDocument.FollowHyperlink Address:="http://www.formletter2pdf.com/en/", NewWindow:=True
End Sub
